//varijable
var fieldNum = 1;
var hints = []; //natuknice
var hintsOrder = []; //redni broj natuknice
var wordWhole = []; //riječi cijele
var words = new Array(101); //riječi podijeljene na slova
var hintNum = 0; //redni broj varijable
var moveDown = false; //kretanje kursora gore ili dolje
var fieldFocus = 0; //polje nakon natuknice
var pictures = []; //slike
var possibleLetterCount = 0; //zbroj mjesta za slova
var usedLetterCount = 0; //zbroj ispunjenih mjesta za slova
var correctLetterCount = 0; //zbroj točnih slova
var gameOn = true; //switch za igru
var activeField = "instruct"; //ID aktivnog polja


var altPressed = false; //za unos kombinacije alt plus tipke
document.addEventListener("keydown", (event) => {
	if ((event.altKey)||(event.ctrlKey)) {altPressed = true;}
	//document.getElementById("test").innerHTML = altPressed;
	//BT
	if ( event.key >= "1" && event.key <= "9" ) event.preventDefault();
});

document.addEventListener("keyup", (event) => {
	if ((!event.altKey)&&(!event.ctrlKey)) {altPressed = false;}
	//document.getElementById("test").innerHTML = altPressed;
	//BT
	if ( event.key >= "1" && event.key <= "9" ) {
		event.preventDefault();
		keyNav(event.key);
	}
});



//generiranje elemenata mreze
for(var j=0;j < 100;j++){
	
	var newElement = document.createElement('div');
	newElement.id = "field".concat(j + 1); newElement.className = "field outline";
	container.appendChild(newElement);

}

//ubacivanje rijeci (polje broj 0-99, h-vodoravno v-okomito, rijec, natuknica)// 
function placeWord(field, direction, word, hint){
 
	wordWhole.push(word);
	hints.push(hint); 

	/*preload slika
	var picture = new Image();
	picture.src = "img/" + word + ".jpg";
	pictures.push(picture);*/

	var letters = word.split("");
	var placeLetter = field; //mjesto slova u mrezi
 
	for(var j=0; j < letters.length; j++){

		if (direction == "v"){
			var idNum = String( "field".concat(field + (j*10)) );
			placeLetter = field + (j*10);
			var idNumInstruct = String( "instruct".concat(field + (j*10)) );
		}
		if (direction == "h"){
			var idNum = String( "field".concat(field + j) );
			placeLetter = field + j;
			var idNumInstruct = String( "instruct".concat(field + j) );
		}
		 
		words.splice(placeLetter, 1, letters[j]);

		var newElement = document.createElement('input');
			newElement.id = idNumInstruct; 
			newElement.className = "input"; 
			newElement.name = letters[j].charCodeAt(0);
			newElement.type = "letter";
			newElement.maxLength = 1;
			newElement.setAttribute("onkeyup","nextField(this.id);");
			newElement.setAttribute("onclick","setActiveField(this.id);");
		
		//BT for aria label (first field)
		if ( j==0 ) newElement.setAttribute("data-label", hint);

		//provjera sadrži li polje input field
		if( document.body.contains(document.getElementById(idNumInstruct)) ){
			if ( j==0 ) document.getElementById(idNumInstruct).setAttribute("data-label", hint);
		}else{
			document.getElementById(idNum).appendChild(newElement);	
		}	

	}

	//ubacivanje ikone za uputu
	var idNum = String("field".concat(field));

	if (direction == "v") var idNumInstruct = String( "instructUp".concat(field) );
	if (direction == "h") var idNumInstruct = String( "instructLeft".concat(field) );

	var newElement = document.createElement('div');

	newElement.id = idNumInstruct;
	hintsOrder.push(idNumInstruct);
	newElement.setAttribute("value",hintNum); hintNum++;
	newElement.setAttribute("onclick","showHint(this.id);");

	if (direction == "v"){ newElement.className = "questionmark positionUp"; } 
	if (direction == "h"){ newElement.className = "questionmark positionLeft"; } 

	document.getElementById(idNum).appendChild(newElement);
	document.getElementById(idNumInstruct).innerHTML = "&nbsp" + fieldNum + "&nbsp"; 
	fieldNum++;
}
 
 
//određivanje aktivnog polja na klik
function setActiveField(active){
	activeField = active;
}
 
 
//prebacivanje kursora u sljedece polje
function nextField(field){ 
	//document.getElementById(field).value = document.getElementById(field).value.toUpperCase();
	var control = field.slice(8,11);
	var fieldID = parseInt(control);
	var character = event.keyCode || event.charCode;

    //provjera smjera kretanja kursora
	if( (character != 16)&&(character != 20)&&(character != 18)&&(character != 17)&&(character != 191) ){
		checkUsedLetters();
		
		if(moveDown == true){
			
			if (character == 46){
				document.getElementById("instruct".concat(fieldID)).value ="";
				document.getElementById("instruct".concat(fieldID - 10)).value ="";
				document.getElementById("instruct".concat(fieldID - 10)).focus();
				activeField = "instruct".concat(fieldID - 10);
				
			}else if ( character == 37 || character == 38 || character == 8 ){
				document.getElementById("instruct".concat(fieldID - 10)).focus();
				activeField = "instruct".concat(fieldID - 10);

			}else{	
				document.getElementById("instruct".concat(fieldID + 10)).focus();
				activeField = "instruct".concat(fieldID + 10);
			}
			
		}else{
			
			if ( character == 46 ){
				document.getElementById("instruct".concat(fieldID)).value ="";
				document.getElementById("instruct".concat(fieldID - 1)).value ="";
				document.getElementById("instruct".concat(fieldID - 1)).focus();
				activeField = "instruct".concat(fieldID - 1);
				
			}else if ( character == 37 || character == 38 || character == 8 ){
				document.getElementById("instruct".concat(fieldID - 1)).focus();
				activeField = "instruct".concat(fieldID - 1);
				
			}else{ 	
				document.getElementById("instruct".concat(fieldID + 1)).focus();
				activeField = "instruct".concat(fieldID + 1);
			}

		}
		
		if(altPressed == true){
			document.getElementById("instruct".concat(fieldID)).focus();
			activeField = "instruct".concat(fieldID);
		}
	}
}

//DE preglasi
function specialChar(umlaut){
      document.getElementById(activeField).value = umlaut;
	  checkUsedLetters();
	
	  var control = activeField.slice(8,11);
	  var fieldID = parseInt(control);

      if ( (moveDown == false) && (document.getElementById("instruct".concat(fieldID + 1)).classList.contains("active")) ){
           document.getElementById("instruct".concat(fieldID + 1)).focus();
		   activeField = "instruct".concat(fieldID + 1); 
		   
	  }else if ( (moveDown == true)&&(document.getElementById("instruct".concat(fieldID + 10)).classList.contains("active")) ) {
           document.getElementById("instruct".concat(fieldID + 10)).focus();
		   activeField = "instruct".concat(fieldID + 10);
	  }	 
}



//provjera ispunjenosti polja	
function checkUsedLetters(){
	possibleLetterCount = 0;
	usedLetterCount = 0;
	var x = document.getElementsByClassName("input");
	for (let e of x) { 
		possibleLetterCount++;
		if ((e.value) != "") usedLetterCount++;
		if ((e.value) == " ") usedLetterCount--;
	}

	if(possibleLetterCount == usedLetterCount){ document.getElementById("checkCross").style.display = "inline-block"; }
} 
 
 
//aktiviranje rijeci
function showHint(hintId){
	 
	if(gameOn == false){return};
	
	//only DE
	if ( document.getElementById("umlauti") ) document.getElementById("umlauti").style.display = "flex";	
	 
	//reset background color
    var x = document.getElementsByClassName("input");
    for (let e of x) { e.disabled = "true"; e.classList.remove("active","error"); e.classList.add("inactive"); }

    var x = document.getElementsByClassName("questionmark");
    for (let e of x) { e.classList.remove("highlight"); }

    //document.getElementById(hintId).style.backgroundColor = "orange";
	document.getElementById(hintId).classList.add("highlight");
	
	var orderNum = hintsOrder.indexOf(hintId);

	if((hintId.slice(8,10)) == "Up"){ 
		moveDown = true;
		fieldFocus = hintId.slice(10,12);
	}else{
		moveDown = false;
		fieldFocus = hintId.slice(12,14);
	}
 
	if (moveDown == false){
		var focusNum = fieldFocus % 10;
		var toNum = (10 - focusNum) + 1;

		for(var j=0; j < toNum; j++){
			if( document.getElementById("instruct" +(parseInt(fieldFocus) + j)) ) {
				document.getElementById("instruct" +(parseInt(fieldFocus) + j)).classList.remove("inactive", "error");
				document.getElementById("instruct" +(parseInt(fieldFocus) + j)).classList.add("active");
				document.getElementById("instruct" +(parseInt(fieldFocus) + j)).disabled = false;
				//BT aria
				document.getElementById("instruct" +(parseInt(fieldFocus) + j)).removeAttribute("aria-label");
				if(j==0) { 
					var firstinput = document.getElementById("instruct" + (fieldFocus));
					firstinput.setAttribute("aria-label", firstinput.dataset.label);
				}
			}else{
				break;
			}
		}
		document.getElementById("instruct" + (fieldFocus)).focus();
		activeField = "instruct" + (fieldFocus);

	}else{
		var focusNum = Math.floor(fieldFocus / 10);
		var toNum = (10 - focusNum) + 1; 

		for(var j=0; j < toNum; j++){
			if ( document.getElementById("instruct" +(parseInt(fieldFocus) + (j*10))) ) {
					document.getElementById("instruct" +(parseInt(fieldFocus) + (j*10))).classList.remove("inactive", "error");	
					document.getElementById("instruct" +(parseInt(fieldFocus) + (j*10))).classList.add("active");
					document.getElementById("instruct" +(parseInt(fieldFocus) + (j*10))).disabled = false;
					//BT aria
					document.getElementById("instruct" +(parseInt(fieldFocus) + (j*10))).removeAttribute("aria-label");
					if(j==0) { 
						var firstinput = document.getElementById("instruct" + (fieldFocus));
						firstinput.setAttribute("aria-label", firstinput.dataset.label);
					}
			}else{
				break;
			}
		} 
		document.getElementById("instruct" + (fieldFocus)).focus();
		activeField = "instruct" + (fieldFocus);
	}
}


//provjera
function check(){
	gameOn = false;
	
	if ( document.getElementById("umlauti") ) document.getElementById("umlauti").style.display = "none";

	//gašenje inputa
	var x = document.getElementsByClassName("input");
	for (let e of x) { e.disabled = "true"; }

	var crossId = 0;
	var crossLetter ="";
	var arrayLetter = "";	
	var dd = 0;
	var x = document.getElementsByClassName("input");

	for (let e of x) { 
		crossId = e.id.slice(8,11);
		crossLetter = e.value.toUpperCase();
		arrayLetter = words[crossId].toUpperCase();

		e.classList.add("inactive");

		if(crossLetter != ""){ e.classList.remove("inactive", "active"); e.classList.add("error"); };	
		if(crossLetter == arrayLetter){ e.classList.remove("inactive", "error"); e.classList.add("active"); correctLetterCount ++; };
	}

	var x = document.getElementsByClassName("questionmark");
	for (let e of x) { e.classList.remove("highlight"); };

	document.getElementById("checkCross").style.display = "none";
	document.getElementById("overlay").style.display = "block";

	if(correctLetterCount == possibleLetterCount){
		document.getElementById("izvrsno").style.display = "block";
	}else{
		document.getElementById("netocno").style.display = "block";
	}
}
 
//restart
function restart(){
	this.location.reload();
}


//BT GET
document.body.onload = function () { document.body.className = GetParameter("para") };
function GetParameter(parameterName) {
	var result = null,
		tmp = [];
	var items = location.search.substr(1).split("&");
	for (var index = 0; index < items.length; index++) {
		tmp = items[index].split("=");
		if (tmp[0] === parameterName) result = decodeURIComponent(tmp[1]);
	}
	return result;
}

function keyNav(key){
	targetdiv = key - 1;
	var target = document.querySelectorAll("div[value='"+targetdiv+"']")[0];
	showHint(target.id);
}

